
clear;

tau=1E-1;

dim=6;

nb_eval=1000;
nb_simplex_grad=floor(nb_eval/(dim+1));

close('all');

h_Optim=figure;


% fx0 for base x0
fx0=60000; 


nb_pb=50;

nb_algo=5;

%avg_min_fx(1:nb_algo)=0;
min_min_fx(1:nb_algo,1:nb_pb)=1E10;
%max_min_fx(1:nb_algo)=-1E10;

col_obj=8;
col_eval_nb=1;

% Get the data
for i_algo=1:nb_algo
    
    for i_pb=1:nb_pb  

        if (i_algo==1)
            statsFileName=['./all_stats_files_for_paper_ortho_np1/stats_2n_nosort.' int2str(int64(i_pb)) '.txt'];
        elseif (i_algo==2)
            statsFileName=['./all_stats_files_for_paper_ortho_np1/stats_2n_suc.' int2str(int64(i_pb)) '.txt'];
        elseif (i_algo==3)
            statsFileName=['./all_stats_files_for_paper_ortho_np1/stats_2n_mod.' int2str(int64(i_pb)) '.txt'];
        elseif (i_algo==4)
            statsFileName=['./all_stats_files_for_paper_ortho_np1/stats_np1_suc_neg.' int2str(int64(i_pb)) '.txt'];
        elseif (i_algo==5)
            statsFileName=['./all_stats_files_for_paper_ortho_np1/stats_np1_mod_opt.' int2str(int64(i_pb)) '.txt'];
        end            
            
        current_stats=[];
        current_stats=load(statsFileName);

% Get feasible improving 
%         i=1;
%         k=1;
%         feasImp=[];
%         min_fx=1E10;
%         while ( i < nb_eval ) 
%             index=find(current_stats(:,col_obj)<min_fx,1);
%             if ( ~ isempty(index) )
%                 i=index+1;
%                 min_fx=current_stats(index,col_obj);
%                 feasImp(k,1)=index ;
%                 feasImp(k,2)=min_fx;
%                 k=k+1;
%             else
%                 i=i+1;
%             end
%         end
%
%        stats(i_algo,i_pb)=struct('data',feasImp);

%     % Best fx found so far
%         min_fx=feasImp(k-1,2);
%         avg_min_fx(i_algo)=avg_min_fx(i_algo)+min_fx/nb_pb;
%         if ( min_fx < min_min_fx(i_algo,i_pb))
%             min_min_fx(i_algo,i_pb)=min_fx;
%         end
%         if ( min_fx > max_min_fx(i_algo) )   
%             max_min_fx(i_algo)=min_fx;
% 
%         end
   
% Stats contain only feasible improving points
        stats(i_algo,i_pb)=struct('data',[ current_stats(:,1) current_stats(:,col_obj) ] );
        last_index=size(current_stats,1);       
        min_min_fx(i_algo,i_pb)=current_stats(last_index,col_obj);
    end
end

for i_algo=1:nb_algo
    mean(min_min_fx(i_algo,:))
    std(min_min_fx(i_algo,:))
    
end


% Get the performance data
%min_min_min_fx=min(min_min_fx(1:nb_algo));
X=zeros(nb_algo+1,nb_simplex_grad);
for alpha=1:nb_simplex_grad
    for i_algo=1:nb_algo
        cnt=0;
        for i_pb=1:nb_pb
            index=find(stats(i_algo,i_pb).data(:,1)>alpha*(dim+1),1);
            if ( isempty(index) )
                index=size(stats(i_algo,i_pb).data(:,1),1);
            end
            if ( (fx0 - stats(i_algo,i_pb).data(index,2)) >= ((1-tau)*(fx0-min(min_min_fx(:,i_pb)))) )
					cnt=cnt+1;
            end
        end;
        X(1,alpha)=alpha;
        X(i_algo+1,alpha)=cnt*100/nb_pb;
    end
end

X=X';

L1=X(round(1+linspace(1,length(X)-1,10)),:);
L2=X(round(3+linspace(1,length(X)-3,11)),:);
L3=X(round(5+linspace(1,length(X)-5,12)),:);
L4=X(round(7+linspace(1,length(X)-7,13)),:);
L5=X(round(9+linspace(1,length(X)-9,14)),:);
%L6=X(round(11+linspace(1,length(X)-11,15)),:);
%L7=X(round(13+linspace(1,length(X)-13,16)),:);

figure(h_Optim);
hold on;

plot ( L1(:,1) , L1(:,2) , 'v', 'LineWidth',1,'MarkerEdgeColor','k','MarkerFaceColor','b','MarkerSize',7 ); 
plot ( L2(:,1) , L2(:,3) , 'd', 'LineWidth',1,'MarkerEdgeColor','k','MarkerFaceColor','g','MarkerSize',7 ); 
plot ( L3(:,1) , L3(:,4) , 'p', 'LineWidth',1,'MarkerEdgeColor','k','MarkerFaceColor','r','MarkerSize',7 ); 
plot ( L4(:,1) , L4(:,5) , 'd', 'LineWidth',1,'MarkerEdgeColor','k','MarkerFaceColor','y','MarkerSize',7 ); 
plot ( L5(:,1) , L5(:,6) , 'o', 'LineWidth',1,'MarkerEdgeColor','k','MarkerFaceColor','k','MarkerSize',7 ); 
%plot ( L6(:,1) , L6(:,7) , 's', 'LineWidth',1,'MarkerEdgeColor','k','MarkerFaceColor','c','MarkerSize',7 ); 
%plot ( L7(:,1) , L7(:,8) , 'x', 'LineWidth',1,'MarkerEdgeColor','k','MarkerFaceColor','y','MarkerSize',7 );


plot( X(:,1) , X(:,2) , 'b--' );    
plot( X(:,1) , X(:,3) , 'g--' );
plot( X(:,1) , X(:,4) , 'r--' );    
plot( X(:,1) , X(:,5) , 'y--' );
plot( X(:,1) , X(:,6) , 'k--' );
%plot( X(:,1) , X(:,7) , 'c--' );    
%plot( X(:,1) , X(:,8) , 'y--' );

title ( ['Data profile NOMAD (3.6.2.beta) (err=' num2str( tau ) ')' ] );
 
axis ( [1 nb_simplex_grad  0  100] );
 
legend ( 'mads 2n nosort', 'mads 2n(suc)','mads 2n(mod)','mads(suc,neg)','mads(mod,opt)'); % ,'mads(suc,opt)','mads(mod,neg)','mads(mod,opt)'); %,'mads(mod,opt)');

xlabel ( 'n+1 evaluations' );
ylabel ( 'Percentage of problems solved' );


globals = struct ('MarkerSize',6,'LineWidth',0.4,'idx_LegendStyle',      1,'GridGreyFac',          0,'StandAloneFile',       1);

fig2texPS(gcf,globals);
